// Copyright © 2015 Lénaïc Bagnères, hnc@singularity.fr

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


#ifndef HOPP_ALGO_HPP
#define HOPP_ALGO_HPP

/**
 * @defgroup hopp_algo Algorithm
 * @copydoc hopp::algo
 */

#include "algo/compare_range.hpp"
#include "algo/find_range.hpp"
#include "algo/random_element.hpp"
#include "algo/replace.hpp"
#include "algo/replace_all.hpp"
#include "algo/replace_range.hpp"
#include "algo/set_difference.hpp"
#include "algo/split.hpp"
#include "algo/sum.hpp"
#include "algo/to_upper.hpp"


namespace hopp
{
	/**
	 * @brief Some basic algorithms
	 *
	 * @code
	   #include <hopp/algo.hpp>
	   @endcode
	 */
	namespace algo
	{
		// For Doxygen only
	}
}

#endif
