// Copyright © 2015 Lénaïc Bagnères, hnc@singularity.fr

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


#ifndef HOPP_GEOMETRY_HPP
#define HOPP_GEOMETRY_HPP

/**
 * @defgroup hopp_geometry Geometry
 * @copydoc hopp::geometry
 */

#include "geometry/is_inside.hpp"
#include "geometry/overlap.hpp"
#include "geometry/rectangle.hpp"


namespace hopp
{
	/**
	 * @brief Provides some geometry classes and functions
	 *
	 * @code
	   #include <hopp/geometry.hpp>
	   @endcode
	 */
	namespace geometry
	{
		// For Doxygen only
	}
}

#endif
