// Copyright © 2015 Lénaïc Bagnères, hnc@singularity.fr

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


#ifndef HOPP_STREAM_HPP
#define HOPP_STREAM_HPP

/**
 * @defgroup hopp_stream Output/Input streams
 *
 * @brief Output/Input streams
 * 
 * @code
   #include <hopp/stream.hpp>
   @endcode
 */

#include "stream/get_line.hpp"
#include "stream/get_until.hpp"
#include "stream/ignore_line.hpp"
#include "stream/ignore_whitespaces.hpp"
#include "stream/ostreamable.hpp"

#endif
