// Copyright © 2013-2015 Lénaïc Bagnères, hnc@singularity.fr

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


#ifndef HOPP_STRING_HPP
#define HOPP_STRING_HPP

#include <string>

/**
 * @defgroup hopp_string Algorithm on strings
 * @copydoc hopp::string
 */

#include "string/remove_leading_whitespaces.hpp"
#include "string/remove_multiple_whitespaces.hpp"
#include "string/remove_trailing_whitespaces.hpp"


namespace hopp
{
	/**
	 * @brief Algorithm on strings
	 *
	 * @code
	   #include <hopp/string.hpp>
	   @endcode
	 */
	namespace string
	{
		// For Doxygen only
	}
}

#endif
