// Copyright © 2015 Université Paris-Sud, Written by Lénaïc Bagnères, lenaic.bagneres@u-psud.fr

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


#ifndef REFERENCE_WRAPPER_IF_LVALUE_HPP
#define REFERENCE_WRAPPER_IF_LVALUE_HPP

#include <memory>


template <class T>
auto reference_wrapper_if_lvalue(T && t) -> decltype(std::forward<T>(t))
{
	//std::cout << "reference_wrapper_if_lvalue(T && t)" << std::endl;
	return std::forward<T>(t);
}

template <class T>
auto reference_wrapper_if_lvalue(T & t) -> decltype(std::cref(t))
{
	//std::cout << "reference_wrapper_if_lvalue(T const & t)" << std::endl;
	return std::cref(t);
}

#endif
