// Copyright © 2015 Université Paris-Sud, Written by Lénaïc Bagnères, lenaic.bagneres@u-psud.fr

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


#ifndef REMOVE_REFERENCE_WRAPPER_HPP
#define REMOVE_REFERENCE_WRAPPER_HPP

#include <memory>


template <class T>
struct remove_reference_wrapper
{
	using type = T;
};

template <class T>
struct remove_reference_wrapper<std::reference_wrapper<T const> const>
{
	using type = T;
};

template <class T>
struct remove_reference_wrapper<std::reference_wrapper<T const>>
{
	using type = T;
};

template <class T>
struct remove_reference_wrapper<std::reference_wrapper<T> const>
{
	using type = T;
};

template <class T>
struct remove_reference_wrapper<std::reference_wrapper<T>>
{
	using type = T;
};

#endif
