// Copyright © 2015 Université Paris-Sud, Written by Lénaïc Bagnères, lenaic.bagneres@u-psud.fr

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


#ifndef VEC1_HPP
#define VEC1_HPP

#include <vector>

#include "expression.hpp"


// vec1<T>

template <class T>
class vec1 : public std::vector<T> // non-conforming inheritance
{
public:
	
	using tag = lazy_expr_tag;
	
	using std::vector<T>::vector;
};

template <class T>
std::ostream & operator <<(std::ostream & out, vec1<T> const & vec1)
{
	out << "{ ";
	
	for (auto const & e : vec1)
	{
		out << e;
		if (&e != &vec1.back()) { out << ","; }
		out << " ";
	}
	
	out << "}";
	
	return out;
}


// get_size

template <class T>
size_t get_size(vec1<T> const & terminal)
{
	return 0; // TODO
}

template
<
	class T,
	class T_is_lazy_expr = typename std::enable_if<std::is_same<typename T::tag, lazy_expr_tag>::value>::type
>
size_t get_size(T const & expr)
{
	return 0; // TODO
}


// get_element_type

template
<
	class T,
	class T_is_lazy_expr = typename std::enable_if<std::is_same<typename T::tag, lazy_expr_tag>::value>::type
>
struct get_element_type
{
	using type = double; // TODO
};

template <class T>
struct get_element_type<vec1<T>>
{
	using type = double; // TODO
};


// compute_from_expr

template <class T>
auto compute_from_expr(T const & terminal, size_t const i)
{
	return 0.0; // TODO
}

template <class T0, class T1>
auto compute_from_expr(lazy_plus<T0, T1> const & expr, size_t const i)
{
	return 0.0; // TODO
}

template <class T0, class T1>
auto compute_from_expr(lazy_minus<T0, T1> const & expr, size_t const i)
{
	return 0.0; // TODO
}

template <class T0, class T1>
auto compute_from_expr(lazy_multiplies<T0, T1> const & expr, size_t const i)
{
	return 0.0; // TODO
}

template <class T0, class T1>
auto compute_from_expr(lazy_divides<T0, T1> const & expr, size_t const i)
{
	return 0.0; // TODO
}

template <class T>
auto compute_from_expr(lazy_negate<T> const & expr, size_t const i)
{
	return 0.0; // TODO
}

template <class T>
vec1<typename get_element_type<T>::type> compute_from_expr(T const & expr)
{
	vec1<typename get_element_type<T>::type> r(get_size(expr));
	
	//#pragma omp parallel for
	for (size_t i = 0; i < r.size(); ++i)
	{
		r[i] = compute_from_expr(expr, i);
	}
	
	return r;
}

#endif
